//+----------------------------------------------------------------------------+
//|                                                          e-SampleCase.mq4  |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  29.10.2006      .                     |
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"
#define   MAGIC     20061029

//-------    ------------------------------------------
extern string _P_Trade = "----------  ";
extern int StopLoss   = 0;                  // 
extern int TakeProfit = 0;                  // 

//-------    --------------------------------------
double Lots         = 0.1;                  // 
int    Slippage     = 3;                    // 
color  clOpenBuy    = LightBlue;            //   
color  clOpenSell   = LightCoral;           //   
color  clModifyBuy  = Aqua;                 //   
color  clModifySell = Tomato;               //   
color  clCloseBuy   = Blue;                 //   
color  clCloseSell  = Red;                  //   

//-------    ------------------------------------------


//+----------------------------------------------------------------------------+
//|  expert start function                                                     |
//+----------------------------------------------------------------------------+
void start() {
  ManagePositions();
}

//+----------------------------------------------------------------------------+
//|                                               |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
void ClosePositions(string sym="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal();

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sym && (op<0 || OrderType()==op)) {
        if (mn<0 || OrderMagicNumber()==mn) {
          if (OrderType()==OP_BUY) {
            OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, clCloseBuy);
          }
          if (OrderType()==OP_SELL) {
            OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, clCloseSell);
          }
        }
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|                                          |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                  (-1 -  )                     |
//|    mn  - MagicNumber              (-1 -  )                       |
//+----------------------------------------------------------------------------+
bool ExistPositions(string sym="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal();

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sym) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) return(True);
          }
        }
      }
    }
  }
  return(False);
}

//+----------------------------------------------------------------------------+
//|    .                                              |
//|  :                                                                |
//|    ms  -                                                     |
//|    ns  -                                                       |
//|    sym -   ("" -  )                    |
//|    tf  -                 ( 0 -  )                 |
//+----------------------------------------------------------------------------+
void GetTradeSignals(bool& ms[], int ns, string sym="", int tf=0) {
  if (sym=="") sym=Symbol();

  //     switch  if
  //      ms:
  // ms[0]=True;   // Buy
  // ms[1]=True;   // Sell
  // ms[2]=True;   // Close Buy
  // ms[3]=True;   // Close Sell
}

//+----------------------------------------------------------------------------+
//|                                                         |
//+----------------------------------------------------------------------------+
void ManagePositions() {
  bool   ms[4];
  double sl=0, tp=0;
  int    i;

  for (i=0; i<4; i++) {
    ArrayInitialize(ms, False);
    GetTradeSignals(ms, i);
    if (ExistPositions("", -1, MAGIC+i)) {
      if (ms[2]) ClosePositions("", OP_BUY, MAGIC+i);
      if (ms[3]) ClosePositions("", OP_SELL, MAGIC+i);
    }
    if (!ExistPositions("", -1, MAGIC+i)) {
      if (ms[0]) {
        if (StopLoss!=0) sl=Ask-StopLoss*Point;
        if (TakeProfit!=0) tp=Ask+TakeProfit*Point;
        OpenPosition("", OP_BUY, sl, tp, MAGIC+i);
      }
      if (ms[1]) {
        if (StopLoss!=0) sl=Bid+StopLoss*Point;
        if (TakeProfit!=0) tp=Bid-TakeProfit*Point;
        OpenPosition("", OP_SELL, sl, tp, MAGIC+i);
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|                                                             |
//|  :                                                                |
//|    sym -   ("" -  )                    |
//|    op  -                                                           |
//|    sl  -                                                               |
//|    tp  -                                                               |
//|    mn  - MagicNumber                                                       |
//+----------------------------------------------------------------------------+
void OpenPosition(string sym, int op, double sl=0, double tp=0, int mn=0) {
  color  clOpen;
  double pp;

  if (sym=="") sym=Symbol();
  if (op==OP_BUY) {
    clOpen=clOpenBuy; pp=Ask;
  } else {
    clOpen=clOpenSell; pp=Bid;
  }
  OrderSend(sym, op, Lots, pp, Slippage, sl, tp, "", mn, 0, clOpen);
}
//+----------------------------------------------------------------------------+

